var http = require('http');

var k2f = function(k) {
  return (k - 273.15) * 1.8 + 32;
}

var getWeatherData = function(lat, lon, callback) {
  var processResponse = function(response) {
    var data = '';
    var getChunk = function(chunk) { data += chunk; }
    
    response.on('data', getChunk);
    response.on('end', function() { callback(data) });
  }
  
  var url = "http://api.openweathermap.org/data/2.5/weather?lat=" + lat + "&lon=" + lon;
  http.get(url, processResponse);
}

var parseWeatherData = function(rawData) {
  var data = JSON.parse(rawData);
  
  return {
    temperature: k2f(data.main.temp),
    condition: data.weather[0].description
  };
}

var sendWeatherData = function(res, data) {
  res.json(this.parseWeatherData(data));
}

var weather = function(req, res, next) {
  var lat = req.query.lat;
  var lon = req.query.lon;

  var self = this;
  self.getWeatherData(lat, lon, function(data) {
    self.sendWeatherData(res, data);
  });
}

exports.k2f = k2f;
exports.getWeatherData = getWeatherData;
exports.parseWeatherData = parseWeatherData;
exports.weather = weather;
exports.sendWeatherData = sendWeatherData;